//
//  CrewMemberTableViewCell.swift
//  expanding-uitableviewcells
//
//  Created by Jake Marsh on 7/30/15.
//  Copyright © 2015 Magnus. All rights reserved.
//

import UIKit

class CrewMemberTableViewCell: UITableViewCell {
  var crewMember: CrewMember? { didSet { if let cm = crewMember { configureForCrewMember(cm) } } }

  @IBOutlet weak var crewMemberImageView: UIImageView!
  @IBOutlet weak var crewMemberNameLabel: UILabel!
  @IBOutlet weak var toolbarStackView: UIStackView!
  @IBOutlet weak var toolbarStackViewHeightConstraint: NSLayoutConstraint!

  override func awakeFromNib() {
    super.awakeFromNib()

    toolbarStackViewHeightConstraint.constant = 0.0
    toolbarStackView.hidden = true
  }
  
  func configureForCrewMember(member: CrewMember) {
    crewMemberImageView.image = UIImage(named: member.imageName)
    crewMemberNameLabel.text = member.name
  }

  override func setSelected(selected: Bool, animated: Bool) {
    super.setSelected(selected, animated: animated)

    let constant: CGFloat = selected ? 30.0 : 0.0

    print("Setting constant to \(constant) - Animated: \(animated)")

    if !animated {
      toolbarStackViewHeightConstraint.constant = constant
      toolbarStackView.hidden = !selected

      return
    }

    UIView.animateWithDuration(0.3, delay: 0.0, options: [.AllowUserInteraction, .BeginFromCurrentState], animations: {
      self.toolbarStackViewHeightConstraint.constant = constant
      self.layoutIfNeeded()
    }, completion: { completed in
      self.toolbarStackView.hidden = !selected
    })
  }
}
