//
//  MasterViewController.swift
//  expanding-uitableviewcells
//
//  Created by Jake Marsh on 7/30/15.
//  Copyright © 2015 Magnus. All rights reserved.
//

import UIKit

struct CrewMember {
  let name: String
  let imageName: String
  var expanded = false

  init(name: String, imageName: String) {
    self.name = name
    self.imageName = imageName
  }
}

class CrewMembersViewController: UITableViewController {
  var crewMembers = [CrewMember]()

  override func viewDidLoad() {
    super.viewDidLoad()

    clearsSelectionOnViewWillAppear = false

    tableView.estimatedRowHeight = 100
    tableView.rowHeight = UITableViewAutomaticDimension

    crewMembers = [
      CrewMember(name: "Ezra Bridger", imageName: "ezra"),
      CrewMember(name: "Kanan Jarrus", imageName: "kanan"),
      CrewMember(name: "Hera Syndulla", imageName: "hera"),
      CrewMember(name: "Sabine Wren", imageName: "sabine"),
      CrewMember(name: "Zeb Orrelios", imageName: "zeb")
    ]
  }

  // MARK: - UITableViewDataSource

  override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
    return 1
  }

  override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
    return crewMembers.count
  }

  override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
    let cell = tableView.dequeueReusableCellWithIdentifier("CrewMemberTableViewCell", forIndexPath: indexPath) as! CrewMemberTableViewCell

    cell.crewMember = crewMembers[indexPath.row]

    return cell
  }

  // MARK: - UITableViewDelegate

  override func tableView(tableView: UITableView, willSelectRowAtIndexPath indexPath: NSIndexPath) -> NSIndexPath? {
    var indexPathToReturn: NSIndexPath?
    var crewMember = crewMembers[indexPath.row]
    
    if crewMember.expanded {
      crewMember.expanded = false

      tableView.deselectRowAtIndexPath(indexPath, animated: true)
      self.tableView(tableView, didDeselectRowAtIndexPath: indexPath)
    } else {
      crewMember.expanded = true
      indexPathToReturn = indexPath
    }

    crewMembers[indexPath.row] = crewMember
    
    return indexPathToReturn
  }
  
  override func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
    tableView.beginUpdates()
    tableView.endUpdates()
  }

  override func tableView(tableView: UITableView, didDeselectRowAtIndexPath indexPath: NSIndexPath) {
    tableView.beginUpdates()
    tableView.endUpdates()
  }
}
